Unit MNR3O_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTMN11_p, UTMN12_p;

procedure MNR3O(var JS :Array of Integer; var S :Integer;
                var DIF :Array of Real; IY :Integer;
                var NS :Array of Integer; var NY :Array of Integer;
                IN_ :Integer; var A :Array of Real;
                var NA :Array of Integer; var C :Array of Real;
                var NC :Array of Integer; N :Integer;
                var XS :Array of Integer; var PR :Integer; EPS :Real);

implementation

procedure MNR3O(var JS :Array of Integer; var S :Integer;
                var DIF :Array of Real; IY :Integer;
                var NS :Array of Integer; var NY :Array of Integer;
                IN_ :Integer; var A :Array of Real;
                var NA :Array of Integer; var C :Array of Real;
                var NC :Array of Integer; N :Integer;
                var XS :Array of Integer; var PR :Integer; EPS :Real);
var
PR1,PR2,J,I,I1,K,J1,L,LA,L1 :Integer;
D :Real;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12;
begin
{   EPBA OTKA PACPEH ACTHOO }
{   PEEH }
L := 1;
J1 := 1;
PR := 0;
for J:=1 to N do
 begin
  K := NC[J-1];
  if ( NS[J1-1] > J ) 
   then goto _10;
  I1 := 1;
  LA := L;
  PR1 := 0;
  PR2 := 0;
  for I:=1 to K do
   begin
    L1 := NA[LA-1];
_1:
    if ( NY[I1-1] > L1 ) 
     then goto _4;
    if ( NY[I1-1] < L1 ) 
     then goto _3;
    D := DIF[I1-1]-Abs(A[LA-1]);
    if ( D >= EPS ) 
     then goto _3;
    if ( A[LA-1] < 0 ) 
     then goto _2;
    PR2 := 1;
    goto _3;
_2:
    PR1 := 1;
_3:
    I1 := I1+1;
    if ( I1 > IY ) 
     then goto _5;
    goto _1;
_4:
    LA := LA+1;
   end;
_5:
  if ( PR1 = 1 ) and ( PR2 = 0 ) 
   then goto _6;
  if ( PR1 = 0 ) and ( PR2 = 1 ) 
   then goto _7;
  goto _9;
_6:
  UTMN11(J,XS);
  S := S+1;
  JS[S-1] := J;
  PR := 1;
  goto _12;
_7:
  UTMN12(J,XS);
  S := S+1;
  JS[S-1] := -J;
_8:
  PR := 1;
_9:
  J1 := J1+1;
  if ( J1 > IN_ ) 
   then goto _12;
_10:
  L := L+K;
_11:
 end;
_12:
end;

end.
