Unit MNR3C_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure MNR3C(var JS :Array of Integer; S :Integer; S1 :Integer;
                var Y :Array of Real; M :Integer;
                var A :Array of Real; var NA :Array of Integer;
                var C :Array of Real; var NC :Array of Integer;
                N :Integer);

implementation

procedure MNR3C(var JS :Array of Integer; S :Integer; S1 :Integer;
                var Y :Array of Real; M :Integer;
                var A :Array of Real; var NA :Array of Integer;
                var C :Array of Real; var NC :Array of Integer;
                N :Integer);
var
ST,DS,J1,I,I1,K,L,J :Integer;
const
COFZ :Integer = 32000;
label
_1,_2,_3,_4,_5,_6,_7;
begin
{   KOPPEKTPOBKA HEBOK Y(M) }
DS := 1;
if ( S1 <= S ) 
 then DS := -1;
ST := S;
if ( DS = 1 ) 
 then ST := ST+1;
_1:
J1 := JS[ST-1];
if ( J1 < 0 ) and ( DS = 1 ) 
 then goto _5;
if ( J1 < 0 ) and ( ST <> S1 ) 
 then goto _6;
if ( J1 > 0 ) and ( ST = S1 ) 
 then DS := 1;
J1 := Abs(J1);
L := 1;
for J:=1 to N do
 begin
  K := NC[J-1];
  if ( J1 > COFZ )        
   then J1 := J1-COFZ;
  if ( J1 <> J ) 
   then goto _3;
  for I:=1 to K do
   begin
    I1 := NA[L-1];
    Y[I1-1] := Y[I1-1]-DS*A[L-1];
_2:
    L := L+1;
   end;
  goto _4;
_3:
  L := L+K;
_4:
 end;
_5:
if ( ST = S1 ) 
 then goto _7;
_6:
ST := ST+DS;
goto _1;
_7:
end;

end.
