Unit MNR3R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, MNR3Y_p, MNR3M_p, MNR3Z_p, MNR3N_p, MNR3D_p, MNR3O_p, MNR3T_p,
MNR3C_p, MNR3L_p;

procedure MNR3R(var X :Array of Integer; var XS :Array of Integer;
                var A :Array of Real; var NA :Array of Integer;
                var B :Array of Real; var C :Array of Real;
                var NC :Array of Integer; M :Integer;
                N :Integer; var Y :Array of Real; var Z :Real;
                var ZS :Real; S :Integer;
                var NY :Array of Integer; var NX :Array of Integer;
                var DIF :Array of Real; EPS :Real);

implementation

procedure MNR3R(var X :Array of Integer; var XS :Array of Integer;
                var A :Array of Real; var NA :Array of Integer;
                var B :Array of Real; var C :Array of Real;
                var NC :Array of Integer; M :Integer;
                N :Integer; var Y :Array of Real; var Z :Real;
                var ZS :Real; S :Integer;
                var NY :Array of Integer; var NX :Array of Integer;
                var DIF :Array of Real; EPS :Real);
var
S1,IY,NS,IN_,I,K,PR,LX :Integer;
const
Z1 :Real = 10.0E+4;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11;
begin
{   BAPAHT METOA AAA C KOMAKTHM }
{   XPAHEHEM CXOHO HOPMA }
LX := (N+31) div 32;
Z := Z1;
if ( S <> 0 ) 
 then goto _2;
for I:=1 to M do
 begin
_1:
  Y[I-1] := B[I-1];
 end;
goto _3;
_2:
MNR3Y(Y,M,A,NA,B,C,NC,N,XS);
_3:
MNR3M(Y,M,NY,IY,EPS);
S1 := S;
if ( S <> 0 ) 
 then goto _4;
ZS := 0;
goto _5;
_4:
MNR3Z(ZS,C,N,XS);
_5:
if ( IY = 0 ) 
 then goto _8;
NS := S+1;
MNR3N(NX,S,ZS,Z,C,N,NX[NS-1],IN_);
if ( IN_ = 0 ) 
 then goto _10;
MNR3D(Y,M,NY,IY,A,NA,C,NC,N,DIF,NX[NS-1],IN_);
for I:=1 to IY do
 begin
  if ( DIF[I-1] < -EPS ) 
   then goto _10;
_6:
 end;
MNR3O(NX,S,DIF,IY,NX[NS-1],NY,IN_,A,NA,C,NC,N,XS,PR,EPS);
if ( PR = 1 ) 
 then goto _7;
MNR3T(NX,S,Y,M,NX[NS-1],IN_,A,NA,C,NC,N,XS,PR,EPS);
_7:
MNR3C(NX,S1,S,Y,M,A,NA,C,NC,N);
goto _3;
_8:
if ( ZS >= Z ) 
 then goto _10;
Z := ZS;
K := 0;
for I:=1 to LX do
 begin
  X[I-1] := XS[I-1];
  K := K+32;
  if ( K >= N ) 
   then goto _10;
_9:
 end;
_10:
S1 := S;
MNR3L(NX,S,XS);
if ( S = 0 ) 
 then goto _11;
goto _7;
_11:
end;

end.
