Unit MNR3T_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTMN11_p;

procedure MNR3T(var JS :Array of Integer; var S :Integer;
                var Y :Array of Real; M :Integer;
                var NS :Array of Integer; IN_ :Integer;
                var A :Array of Real; var NA :Array of Integer;
                var C :Array of Real; var NC :Array of Integer;
                N :Integer; var X :Array of Integer; PR :Integer;
                EPS :Real);

implementation

procedure MNR3T(var JS :Array of Integer; var S :Integer;
                var Y :Array of Real; M :Integer;
                var NS :Array of Integer; IN_ :Integer;
                var A :Array of Real; var NA :Array of Integer;
                var C :Array of Real; var NC :Array of Integer;
                N :Integer; var X :Array of Integer; PR :Integer;
                EPS :Real);
var
I,J,K,LA,L,L1,JMAX,J1 :Integer;
MAX,R1,R,ZE :Real;
label
_1,_2,_5,_3,_4;
begin
{   BTOPA OTKA PACPEH ACTHOO }
{   PEEH }
ZE := -EPS;
L := 1;
J1 := 1;
//MAX := IntPower(-10,4);
MAX := -IntPower(10,4);
for J:=1 to N do
 begin
  K := NC[J-1];
  if ( NS[J1-1] > J )  
   then goto _5;
  R := 0;
  LA := L;
  for I:=1 to K do
   begin
    L1 := NA[LA-1];
    R1 := Y[L1-1]-A[LA-1];
    if ( R1 < ZE ) and ( Y[L1-1] < ZE ) 
     then R := R-A[LA-1];
    if ( R1 < ZE ) and ( Y[L1-1] > ZE ) 
     then R := R+R1;
    if ( R1 >= ZE ) and ( Y[L1-1] < ZE ) 
     then R := R-Y[L1-1];
_1:
    LA := LA+1;
   end;
  if ( R < MAX ) 
   then goto _2;
  MAX := R;
  JMAX := J;
_2:
  J1 := J1+1;
  if ( J1 > IN_ ) 
   then goto _4;
_5:
  L := L+K;
_3:
 end;
_4:
UTMN11(JMAX,X);
S := S+1;
JS[S-1] := JMAX;
end;

end.
